/*  $Id: js_runtime.h,v 1.6 2004/01/02 15:42:44 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/
//! clanJavaScript="Framework"
//! header=javascript.h

#ifndef header_js_runtime
#define header_js_runtime

#if _MSC_VER > 1000
#pragma once
#endif

#include "js_config.h"
#include <map>

class CL_JSContext;

//: JavaScript runtime class.
//- !group=JavaScript/Framework!
//- !header=javascript.h!
class CL_JSRuntime
{
//! Construction:
public:
	CL_JSRuntime(long gc_memory);

	~CL_JSRuntime();

//! Attributes:
public:
	JSRuntime *getRuntime();

	operator JSRuntime *();

//! Operations:
public:
	static CL_JSRuntime *tempFromHandle(JSRuntime *rt);

	static CL_JSRuntime *permanentFromHandle(JSRuntime *rt);

//! Implementation:
private:
	CL_JSRuntime(JSRuntime *runtime, bool tempObject);

	JSRuntime *runtime;

	bool tempObject;

	static std::map<JSRuntime *, CL_JSRuntime *> tempMap;

	static std::map<JSRuntime *, CL_JSRuntime *> permanentMap;
};

#endif
