/*  $Id: opengl.cpp,v 1.16 2003/12/17 16:17:02 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "Display/display_precomp.h"
#include "API/GL/opengl.h"
#include "API/GL/opengl_wrap.h"

#include <GL/gl.h>

#ifndef WIN32
#define GLX_GLXEXT_PROTOTYPES
#include <GL/glx.h>
#endif

CL_ProcAddress *CL_OpenGL::get_proc_address(const std::string& function_name)
{
	#ifdef WIN32
		return (void (*)())wglGetProcAddress(function_name.c_str());
	#else
		#if !defined(GLX_VERSION_1_4)
			return glXGetProcAddressARB((GLubyte*)function_name.c_str());
		#else
			return glXGetProcAddress((GLubyte*)function_name.c_str());
		#endif
	#endif
}

CL_GLFunctions *CL_OpenGL::functions = 0;
