/*  $Id: js_arguments.cpp,v 1.2 2003/07/20 22:22:17 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#include "API/JavaScript/js_arguments.h"

/////////////////////////////////////////////////////////////////////////////
// Construction:

CL_JSArguments::CL_JSArguments(CL_JSContext *cx, uintN argc, jsval *argv)
: dummy(cx)
{
	numValues = argc;
	values = new CL_JSValue[numValues];
	for (int i=0; i<numValues; i++)
	{
		values[i] = CL_JSValue(cx, argv[i]);
	}
}

CL_JSArguments::~CL_JSArguments()
{
	delete[] values;
}

/////////////////////////////////////////////////////////////////////////////
// Attributes:

CL_JSValue &CL_JSArguments::operator[](int arg)
{
	if (arg < 0 || arg >= numValues)
	{
		dummy.setNull();
		return dummy;
	}
	return values[arg];
}

int CL_JSArguments::size() const
{
	return numValues;
}

/////////////////////////////////////////////////////////////////////////////
// Implementation:
