/*  $Id: voice_decoder_generic.h,v 1.7 2003/10/14 15:52:13 mbn Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

#ifndef header_voice_decoder_generic
#define header_voice_decoder_generic

#if _MSC_VER > 1000
#pragma once
#endif

#include "API/Sound/soundformat.h"

class CL_VoiceDecoder_Generic
{
//! Construction:
public:
	CL_VoiceDecoder_Generic() { return; }
	
	virtual ~CL_VoiceDecoder_Generic() { return; }
	
//! Attributes:
public:
	int freq;

	CL_SoundFormat format;

	int num_channels;

	int num_samples;

	int position;
	
//! Operations:
public:
	virtual void decode_packet(const std::string &packet)=0;

	virtual int get_data(void **data_ptr, int data_requested)=0;
	
//! Implementation:
private:
};

#endif
